Assets = {}
PrefabFiles = {
		--'dummy_firesuppressor',
}

local TheInput = GLOBAL.TheInput
local GetWorld = GLOBAL.GetWorld
local GetClock = GLOBAL.GetClock

local IsDLC1 = GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS)
local IsDLC2 = GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC)
local IsMainGame = not (IsDLC1 or IsDLC2)

local IsDST = GLOBAL.TheSim:GetGameID() == "DST"
local IsServer = not IsDST or GLOBAL.TheNet:GetIsServer()

local LAN = GetModConfigData("LANGUAGE")
local FIRESUPPRESSOR_PLACER = GetModConfigData("FIRESUPPRESSOR PLACER")
local MOON = GetModConfigData("MOON")
local PACK_ARMOR = GetModConfigData("PACK ARMOR")
local PERSONAL = GetModConfigData("PERSONAL")
local BEAUTIFUL_SLOTS = GetModConfigData("BEAUTIFUL SLOTS")
local SELECT_CHAR = GetModConfigData("SELECT CHAR")
--local BETA = GetModConfigData("BETA")

local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS

local Action = GLOBAL.Action
local ActionHandler = GLOBAL.ActionHandler
local ACTIONS = GLOBAL.ACTIONS

local ST = GLOBAL.STRINGS

local EQUIPSLOTS = GLOBAL.EQUIPSLOTS

--
if LAN then
	GLOBAL.require'FD_strings_C' 
else
	GLOBAL.require'FD_strings_E'
end

--
function isKeyDown(key,paused)
	if not GLOBAL.InGamePlay() then
		return false
	end
	if paused and GLOBAL.IsPaused() then
		return false
	end
	if key then
		if type(key) == 'table' then
			for k,v in ipairs(key) do
				if not TheInput:IsKeyDown(v) then return false end
			end
		else
			if not TheInput:IsKeyDown(key) then return false end
		end
		return true
	end
	return not TheInput:IsKeyDown(GLOBAL.KEY_CTRL) and not TheInput:IsKeyDown(GLOBAL.KEY_SHIFT) and not TheInput:IsKeyDown(GLOBAL.KEY_ALT)
end
--例 isKeyDown(GLOBAL.KEY_CTRL,true)
-- 按下CTRL为真。   GLOBAL.KEY_CTRL也可为表 （如{GLOBAL.KEY_CTRL,GLOBAL.KEY_SHIFT} 同时按下 CTRL 和 SHIFT才为真）
--true 表示暂停游戏时总是假
function isModEnabled(name)
	if not name then return false end
	local t = false
	for _, moddir in ipairs(GLOBAL.KnownModIndex:GetModsToLoad()) do
		if GLOBAL.KnownModIndex:GetModInfo(moddir).name == name then
			t = true
		end
	end
	return t
end

GLOBAL.is_Sign_Plugs_mod_enabled = isModEnabled('SignPlus')

----Action
local A_AEdit = Action(2)
A_AEdit.str = ST.A_AEdit
A_AEdit.id = "A_AEdit"
A_AEdit.fn = function(act)
		local tar = act.target
		if tar and tar.components.A_AEdit then
			tar.components.A_AEdit:OnRightClick(tar)
		end
		return true
end

AddAction(A_AEdit)

AddPlayerPostInit(function(inst)
	if inst and inst.sg and inst.sg.sg and inst.sg.sg.actionhandlers then
		inst.sg.sg.actionhandlers[ACTIONS.A_AEdit] = ActionHandler(ACTIONS.A_AEdit,"dolongaction")
	end
 end)
--AddSimPostInit(function(inst)
--	if not GLOBAL.rawget(GLOBAL,"SGManager") then
--		print("ERROR: Not a DS game.")
--		return --Not a DS game.
--	end
--	for instance,_ in pairs(GLOBAL.SGManager.instances) do
--		if(instance.sg.name == "wilson" or instance.sg.name == GLOBAL.tostring(inst and inst.prefab)) then
--			print(inst)
--			print(instance.sg.name)
--			AddStategraphActionHandler(instance.sg.name, ActionHandler(ACTIONS.A_AEdit,"dolongaction"))
--		end
--	end
--end)

local function TweakSign(inst)
--	if not inst.Label then
--		local L = inst.entity:AddLabel()
--		L:SetFontSize(GLOBAL.TUNING.ENTITY_LABEL_SIZE)
--		L:SetFont(GLOBAL.BODYTEXTFONT)--BODYTEXTFONT  BUTTONFONT
--		L:SetPos(.2, .2, -.2)
		--L:SetColour(math.random(),math.random(),math.random())
--		L:Enable(false)
--	end
		inst:AddComponent("A_AEdit")
		inst:DoTaskInTime(0,function() inst.components.A_AEdit:IsComponentType('Other') end)
end

AddPrefabPostInit("homesign", TweakSign) --路牌
AddPrefabPostInit("buoy", TweakSign) -- 航灯
AddPrefabPostInit("gravestone", TweakSign) -- 墓碑
--AddPrefabPostInit("redsign", TweakSign)
--AddPrefabPostInit("bluesign", TweakSign)
--AddPrefabPostInit("greensign", TweakSign)
--AddPrefabPostInit("pinksign", TweakSign)

--==================================CHAR=================================
if SELECT_CHAR then
		table.insert(Assets,Asset("IMAGE", "bigportraits/locked.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/locked.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/wathgrithr.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/wathgrithr.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/waxwell.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/waxwell.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/webber.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/webber.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/wendy.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/wendy.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/wes.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/wes.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/wickerbottom.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/wickerbottom.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/willow.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/willow.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/wilson.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/wilson.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/wolfgang.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/wolfgang.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/woodie.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/woodie.xml"))
		table.insert(Assets,Asset("IMAGE", "bigportraits/wx78.tex"))
		table.insert(Assets,Asset("ATLAS", "bigportraits/wx78.xml"))
		
		table.insert(Assets,Asset("IMAGE", "images/selectscreen_portraits.tex"))
		table.insert(Assets,Asset("ATLAS", "images/selectscreen_portraits.xml"))
		table.insert(Assets,Asset("ANIM", "anim/portrait_frame.zip"))

if IsDLC2 then
	table.insert(Assets,Asset("IMAGE", "bigportraits/walani.tex"))
	table.insert(Assets,Asset("ATLAS", "bigportraits/walani.xml"))
	table.insert(Assets,Asset("IMAGE", "bigportraits/warly.tex"))
	table.insert(Assets,Asset("ATLAS", "bigportraits/warly.xml"))
	table.insert(Assets,Asset("IMAGE", "bigportraits/wilbur.tex"))
	table.insert(Assets,Asset("ATLAS", "bigportraits/wilbur.xml"))
	table.insert(Assets,Asset("IMAGE", "bigportraits/woodlegs.tex"))
	table.insert(Assets,Asset("ATLAS", "bigportraits/woodlegs.xml"))
end

	local CharacterSelectScreen = GLOBAL.require "screens/characterselectscreen"

		local function SelectChar()
			local player = GetPlayer()
			local profile = player and player.profile
			local isdead = player and player.components.health:IsDead()
			if profile and not isdead then
				local oldCharacter = player.prefab
				
				local SelctScr = CharacterSelectScreen(profile, 
					function(character)
						GLOBAL.TheFrontEnd:PopScreen(SelctScr)
						if character and character ~= player.prefab then
							player.sg:GoToState("teleportato_teleport")
							
							GLOBAL.TheFrontEnd:Fade(false, 8, function()
								profile:Save(function()
									GLOBAL.SaveGameIndex:SaveCurrent()
									GLOBAL.SaveGameIndex:SetSlotCharacter(GLOBAL.SaveGameIndex:GetCurrentSaveSlot(), character, function() 
										GLOBAL.StartNextInstance({reset_action=GLOBAL.RESET_ACTION.LOAD_SLOT, save_slot = GLOBAL.SaveGameIndex:GetCurrentSaveSlot(), playeranim="failadventure", character = character}, true)
									end)
								end)
							end)
						end
					GLOBAL.SetPause(false)
					end), true
				
				GLOBAL.SetPause(true)
				SelctScr:SelectCharacter(oldCharacter)
				GLOBAL.TheFrontEnd:PushScreen(SelctScr)
			end
		end

	TheInput:AddKeyUpHandler(GLOBAL.KEY_N, function()
		if isKeyDown(GLOBAL.KEY_SHIFT,true) then
			SelectChar()
		end
	end)
end
--==================================PLACER=================================
local function FiresuppressorPI(inst)
	if inst.components.inspectable then
		local OldFn = inst.components.inspectable.getstatus
		inst.components.inspectable.getstatus = function(inst,viewer,...)					
			if not inst.placer then
				inst.placer = GLOBAL.SpawnPrefab('firesuppressor_placer')
				inst.placer.Transform:SetPosition(inst:GetPosition():Get())
				inst.placer.AnimState:SetAddColour(.25, .75, .25 ,0)
				inst.placer:DoTaskInTime(45,function() if inst.placer then inst.placer:Remove() inst.placer = nil end end)
			else
				inst.placer:Remove()
				inst.placer = nil
			end
		return OldFn(inst,viewer,...)
		end
	end
end
if not IsMainGame and FIRESUPPRESSOR_PLACER then
	table.insert(PrefabFiles,'dummy_firesuppressor')
	
	local dummy_firesuppressor = Recipe("dummy_firesuppressor", {}--[[{Ingredient("cutgrass", 1)}]], RECIPETABS.SCIENCE, {SCIENCE = 0},IsDLC2 and GLOBAL.RECIPE_GAME_TYPE.COMMON or "firesuppressor_placer", IsDLC2 and "firesuppressor_placer")
	dummy_firesuppressor.atlas = "images/inventoryimages.xml"
	dummy_firesuppressor.image = 'firesuppressor.tex'
	
	AddPrefabPostInit("firesuppressor", FiresuppressorPI)
end
--==================================MOON=================================
local function UIClockPostInit(self)
	local  OldFn = self.ShowMoon
    function self:ShowMoon(...)
        local omp,mp = GetClock():GetMoonPhase()
		if type(mp) == 'string' then
			local moon_syms = 
			{
				new="moon_new",
				quarter="moon_quarter",
				half="moon_half", --上
				threequarter="moon_three_quarter",
				full="moon_full",
				waningthreequarter="moon_three_quarter",
				waninghalf="moon_half", --下
				waningquarter="moon_quarter",
			}
			self.moonanim:GetAnimState():OverrideSymbol("swap_moon", "moon_phases", moon_syms[mp] or "moon_full")
			local s = 1
			local p = 15
			self.moonanim:SetPosition((string.find(mp, "waning") == nil and mp ~= 'full') and -(p+10) or p+10,p,0)
			self.moonanim:SetScale((string.find(mp, "waning") == nil and mp ~= 'full' ) and -s or s,s,s)
			self.moonanim:GetAnimState():PlayAnimation("trans_out") 
			self.moonanim:GetAnimState():PushAnimation("idle", true) 
		else
			OldFn(self,...)
		end
    end
    
    local function Moon()
		local omp,mp = GetClock():GetMoonPhase()
		if type(mp) == 'string' and string.find(mp, "waning") == nil then--and mp ~= 'new' then
			if GetClock():IsDusk() then
				self:ShowMoon()
			end
		end	
    end
    
	Moon()
	self.inst:ListenForEvent( "dusktime",Moon,GetWorld())
end

local function ClockComponentPostInit(self,inst)
    local moonphases = 
    {
        "new",
        "quarter",
        "half",
        "threequarter",
        "full",
        "waningthreequarter",
        "waninghalf",
        "waningquarter",
    }
    
    local OldFn = self.GetMoonPhase
    
    function self:GetMoonPhase(...)
        local phaselength = 2
        local n = #moonphases
        
        local idx = math.floor(self.numcycles/phaselength) % n
      --  print(moonphases[idx+1]..'第'..self.numcycles..'+1天'..OldFn(self))
        return OldFn(self,...),moonphases[idx+1]
    end
end

if MOON then
	AddComponentPostInit("clock", ClockComponentPostInit)
	AddClassPostConstruct("widgets/uiclock", UIClockPostInit)
end
--==================================HOT KEY=================================
--==================================BP and AM slot============================
if PACK_ARMOR then
	local ITEMSLOTS = GetModConfigData("ITEMSLOTS") or 0
	GLOBAL.MAXITEMSLOTS = IsDST and (GLOBAL.MAXITEMSLOTS or 15) + ITEMSLOTS --dst change inventory size
		
	local function canaddeqslot()
		for k,v in pairs(EQUIPSLOTS) do
			if v then
				local _,n1 = string.find(v,'ack') --back
				--local _,n2 = string.find(v,'eck') --neck
				if n1 then --or n2 then
					return false
				end
			end
		end
		return EQUIPSLOTS.BPAM == nil
	end	
	local function Pf_PI_A(inst) --dst Server  ds
		if EQUIPSLOTS.BPAM == nil
			or not inst
			or not inst.components
			or not inst.components.equippable then return end
		if inst.components.equippable.equipslot == EQUIPSLOTS.BODY 
			and( inst.components.container or inst.components.armor) then
			inst.components.equippable.equipslot = EQUIPSLOTS.BPAM
		end
	end
	local function InvBar_PC(self) --dst ds
		if EQUIPSLOTS.BPAM == nil or self.bpamslot ~= nil then return end
		self.bpamslot = true
		
		self:AddEquipSlot(EQUIPSLOTS.BPAM, "images/bpam.xml", "bpam.tex")
		
		local function bgc()
			local a = ITEMSLOTS*1.25
			local b = #self.equipslotinfo
			local c = IsDST and 1.25 or 0
			local abc = (a+b+c)*0.05
			self.bg:SetScale(1+abc,1,1)
			self.bgcover:SetScale(1+abc,1,1)
		end
		
		local OldRebuild = self.Rebuild
		function self:Rebuild(...)
			OldRebuild(self,...)
			bgc()
		end
	end
	local function Hud_PC(self) --ds
		if EQUIPSLOTS.BPAM == nil then return end
		local OldFn = self.SetMainCharacter
		function self:SetMainCharacter(maincharacter,...)
			OldFn(self, maincharacter,...)
			if not(self.controls and self.controls.inv) then return end
			local pack = maincharacter.components.inventory:GetEquippedItem(EQUIPSLOTS.BPAM)
			if pack and pack.components.container then
				pack.components.container:Close()
				pack.components.container:Open(maincharacter)
			end
		end
	end
	if canaddeqslot() then
		table.insert(Assets,Asset("IMAGE", "images/bpam.tex"))
		table.insert(Assets,Asset("ATLAS", "images/bpam.xml"))		
		EQUIPSLOTS.BPAM = 'bpam'
		AddClassPostConstruct("widgets/inventorybar", InvBar_PC)
		
		if IsServer then
			AddPrefabPostInitAny(Pf_PI_A)
		end
		
		if not IsDST then
			AddClassPostConstruct("screens/playerhud", Hud_PC)
			AddComponentPostInit("inventory",function(self,inst) --ds change inventory size
				self.maxslots = (self.maxslots or 15) + ITEMSLOTS
			end)
		else
			AddComponentPostInit("inventory", function(self,inst) --dst get overflow
				self.GetOverflowContainer = function()
					if self.ignoreoverflow then return end
					local item = self:GetEquippedItem(EQUIPSLOTS.BPAM)
					return item ~= nil and item.components.container or nil
				end
			end)
		end
	end
end

--=================================Camera==Beautiful Slots  【PERSONAL】============================
local function P_PI(inst)
	inst:DoTaskInTime(0,function() GLOBAL.TheCamera:SetHeadingTarget(0) end)
end
if PERSONAL then
	--镜头自动旋转
	AddPlayerPostInit(P_PI) 
end
local function CTN_CPN_PI(self,inst)
	if not self.A_ATint then
		local function addtint()
			if inst:HasTag('fridge') or inst.ChesterState == "SNOW" then -- 冰箱
				self.A_ATint = {32/255,  120/255,  242/255, .85}
			elseif inst.components.stewer or inst.PackimState == 'FIRE' then -- 锅  火鹈鹕
				self.A_ATint = {179/255,  22/255,  66/255, .85}
			elseif  inst.ChesterState == "SHADOW" then --暗影切斯特
				self.A_ATint = {30/255,  30/255,  30/255, .85}
			else
				return
			end
			if inst.A_Atintevent then inst.A_Atintevent = nil inst:RemoveEventCallback('onopen',addtint) end
		end	
		addtint()
		if self.A_ATint then return end --非宠物类 到此结束
		
		inst:DoTaskInTime(0,function()
			addtint()
			if self.A_ATint then return end --宠物类已经变身 到此结束
			if (inst.ChesterState or inst.PackimState) and not inst.A_Atintevent then
				inst.A_Atintevent = true
				inst:ListenForEvent('onopen',addtint) --没变身的监听打开事件，若变身则改变格子颜色
			end
		end)
	end
end
local function INV_PC(self)
	if self.bgimage and self.container and not self.container.widgetbgimagetint and self.container.A_ATint then
		self.bgimage:SetTint(self.container.A_ATint[1], self.container.A_ATint[2], self.container.A_ATint[3], self.container.A_ATint[4])
	end
end
if BEAUTIFUL_SLOTS then
	--格子美化
	AddComponentPostInit('container',CTN_CPN_PI)
	AddClassPostConstruct("widgets/invslot", INV_PC)
end
--=============================================================================
modimport "scripts/A_Alabel.lua" 
modimport "scripts/A_Afor_dawdler.lua"

--if BETA then
--modimport "scripts/A_Afor_dawdler.lua" 
--else
--modimport "scripts/A_Afor_dawdler_previous.lua" 
--end

		--wathgrithr
		--waxwell
		--webber
		--wendy
		--wes
		--wickerbottom
		--willow
		--wilson
		--wolfgang
		--woodie
		--wx78
--[[SW]]		
		--walani
		--warly
		--wilbur
		--woodlegs		