local require = GLOBAL.require
local ST = GLOBAL.STRINGS
GetPlayer = GLOBAL.GetPlayer
TheInput = GLOBAL.TheInput
local Vector3 = GLOBAL.Vector3
local unpack = GLOBAL.unpack

local ImageButton = require "widgets/imagebutton"
local TextButton = require "widgets/textbutton"
local Image = require "widgets/image"
local cooking = require 'cooking'

local PLAYER_FOLLOW_MOUSE = type(GetModConfigData("PLAYER FOLLOW MOUSE")) == 'number'
local FREE_SLOTS = GetModConfigData("FREE SLOTS") or 2
local PACK_FREE_SLOTS = GetModConfigData("PACK FREE SLOTS") or 0
local PREDICT_FOOD = GetModConfigData("PREDICT FOOD")
local SORT_BUTTON_POSITION = GetModConfigData("SORT BUTTON POSITION")
local SORT_KEY = GetModConfigData("SORT KEY") or 122

local CHEST_METHOD = {'SELF','FIRST_SLOT','ALL_SLOTS','OT_C','WE_C','AR_C','TO_C','LI_C','CL_C','EQ_C','AN_C',}
local Sort_Button_Position = {left = {-866,140,0},right = {866,140,0},above = {0,1250,0},	hide = {0,-200,0},middle = {0,140,0},}
local A_AST = {}
A_AST.STACK_FOOD = GetModConfigData("STACK FOODS")
A_AST.FOOD_TYPE = 'PERISH'
A_AST.SORT_METHOD = true
A_AST.CustomItems = ST.A_ASTCustomItems

--	BODYTEXTFONT	DIALOGFONT	UIFONT	BUTTONFONT	TALKINGFONT
local textfont = GetModConfigData("LANGUAGE") and GLOBAL.BUTTONFONT or GLOBAL.DIALOGFONT
GLOBAL.A_A_TEXTFONT_LAN = textfont

--分类用的，叠加   直接复制Brody的代码 Thanks！
local function average(value1, amount1, value2, amount2)
    local total1 = value1*amount1
    local total2 = value2*amount2
    local total = total1 + total2
    return total/(amount1+amount2)
end
local function combine_stacks(item1, item2)
    if not item1 then return end
    if not item1.components.stackable then return end
    local size1 = item1.components.stackable.stacksize
    local size2 = item2.components.stackable.stacksize
    local max_size = item1.components.stackable.maxsize
    local combined_size = size1+size2
	local perish_time,perish_time_1,perish_time_2 = nil
        perish_time_1 = item1.components.perishable and item1.components.perishable.perishremainingtime
        perish_time_2 = perish_time_1 and item2.components.perishable.perishremainingtime
	
    if size1 < max_size then
        if combined_size <= max_size then
            --just combine the stacks
            if perish_time_1 then
                -- the item will perish so average the together
                perish_time = average(perish_time_1, size1, perish_time_2, size2)
                item1.components.perishable.perishremainingtime = perish_time
            end
            item1.components.stackable.stacksize = combined_size
			item2:Remove()
            return true
        elseif size1 + size2 > max_size then
            local amount_moved = max_size - size1
            local amount_left = size2 - amount_moved
            if perish_time_1 then
                -- the item will perish so average the together
                perish_time = average(perish_time_1, size1, perish_time_2, amount_moved)
                item1.components.perishable.perishremainingtime = perish_time
                -- perish_time_2 stays the same because nothing is added to it
            end
            item1.components.stackable.stacksize = max_size
            item2.components.stackable.stacksize = amount_left
            return false
        end
    end
    return false
end
--获取分类信息  --ComponentPostInit
local function INV_CTN_PI(self,inst)
	local S_itemtype = {	razor='Tool',compass='Tool',umbrella='Tool',grass_umbrella='Tool',
						lighter='Light',torch='Light',lantern='Light',molehat='Light',
						sewing_kit='Clothing',
						tallbirdegg='Food',lightbulb='Food',wormlight='Food',
					}
	function self:A_AGetItemInfo(slot)
		local item = self.itemslots and self.itemslots[slot] or self.slots and self.slots[slot]
		if not item then return end
		
		local itemtype = S_itemtype[item.prefab]
		if itemtype == 'Weapon' and not item.components.weapon 
			or itemtype == 'Armor' and not item.components.armor 
			or itemtype == 'Food' and not item.components.edible 
			then
			itemtype = 'Variable' --mod装备RemoveComponent bug 定义为可变类型，每次整理都要重新判断
		end
		if not itemtype or itemtype == 'Variable' then
			local Variable_Item_Type = itemtype
			if item.Light --矿工帽  南瓜灯   或其他会发光的物品   
				or item.components.fader --大概也是光源吧   mod方面也只能做到这了
				then --话说能发光的东西难道就不能来个统一的标签吗？？
					itemtype = 'Light'
			elseif item.components.weapon
				and item.components.weapon.damage >= 20
				and ( not item.components.tool or item.components.weapon.damage >= 30)
				and ( not item.components.terraformer or item.components.weapon.damage >= 30)  --草叉
				then
					itemtype = 'Weapon'
			elseif item.components.armor then
				itemtype = 'Armor'
			elseif item.components.tool
				or item.components.terraformer --草叉
				or item.components.sleepingbag --草席卷等
				or item.components.fishingrod --钓竿
				or item.components.trap --陷阱
				then
					itemtype = 'Tool'
			elseif item.components.equippable
				or item.components.fan --羽毛扇
				then
					itemtype = 'Clothing'
			elseif item.components.edible
				and item.components.perishable 
				then
					itemtype = 'Food'
			else
				itemtype = 'Others'
			end
			S_itemtype[item.prefab] = Variable_Item_Type or itemtype
			--print('Added Itemtype:    '..item.prefab..'    is    '..(Variable_Item_Type or itemtype))
		end
	return {inst = item,Type = itemtype}
	end
end
AddComponentPostInit('inventory',INV_CTN_PI)
AddComponentPostInit('container',INV_CTN_PI)
--基础
local function isnormalchest(chest)
	return chest and chest.components.container and chest.components.container.acceptsstacks and not (chest.components.equippable or chest.components.stewer or chest.components.drivable )
end
local function isfreezer(chest)
	return chest and chest:HasTag('fridge')
end
local function ispet(chest)
	return chest and chest.components.locomotor
end
local function getbackpack(player)
	local pack = nil
	for c,b in pairs(player.components.inventory.opencontainers) do
		if b and c and c.components.equippable then
			pack = pack and pack.components.container.numslots >= c.components.container.numslots and pack or c
		end
	end
	return pack
end
local function getopenchest(player)
	local chest = nil
	for c,b in pairs(player.components.inventory.opencontainers) do
		if b and c and isnormalchest(c) then
			chest = chest and chest.components.container.numslots >= c.components.container.numslots and chest or c
		end
	end
	return chest
end
--箱子模式等保存，添加 edit 组件  --ComponentPostInit   save--load
local function CTN_CPN_PI(self,inst)
		self.Chest_Method = nil
		self.BAIBAO_CHEST = false
		--为了loading时执行onload功能，必须在这里添加。		
		inst:AddComponent('A_AEdit')
	 --save & load
		local OldS = self.OnSave
	    function self:OnSave(...)
			local data = OldS(self,...)
			data.Chest_Method = self.Chest_Method
			data.BAIBAO_CHEST = self.BAIBAO_CHEST
			return data
	    end
		local OldL = self.OnLoad
	    function self:OnLoad(data, newents,...)
			local dfn = OldL(self,data, newents,...)
			if data then
				self.Chest_Method = data.Chest_Method or 'SELF'
				self.BAIBAO_CHEST = data.BAIBAO_CHEST or false
			end
			return dfn
	    end
	    
	inst:DoTaskInTime(0,function()--在这里判断是否需要保留A_AEdit功能  因为在初始化结束后才能判断箱子类型 inst.prefab 才是有效值
		local IsContainer = isnormalchest(inst)
		local IsPet = ispet(inst)
		local IsFridge =IsContainer and not IsPet and isfreezer(inst)
		if not self.Chest_Method then self.Chest_Method = (IsFridge and GetModConfigData("DEFAULT FRIDGE METHOD")) or GetModConfigData("DEFAULT CHEST METHOD") end --新建箱子时判断箱子类型后赋予初始模式
				local type = IsPet and 'Pet' or IsFridge and 'Fridge' or IsContainer and 'Container' or 'OtherContainer'
				inst.components.A_AEdit:IsComponentType(type)
		if IsContainer and not IsPet and inst.components.A_AEdit then
			--如意箱 检测是否放入东西，改变文字
			inst:ListenForEvent('itemget',function(inst,data) if self.Chest_Method == 'FIRST_SLOT' and data and data.slot==1 then inst.components.A_AEdit:UpdataString() end end)
			inst:ListenForEvent('itemlose',function(inst,data) if self.Chest_Method == 'FIRST_SLOT' and data and data.slot==1 then inst.components.A_AEdit:UpdataString() end end)
		end
	end)
end
AddComponentPostInit("container", CTN_CPN_PI)
-- FOOD FOOD FOOD FOOD FOOD FOOD predict food FOOD FOOD FOOD FOOD FOOD FOOD FOOD FOOD FOOD-----------------------------------------------
local function Pot_PI(inst)
	inst:AddComponent('A_ACookpot')
end
local function Stewer_PI(self,inst)
		local oldfn = self.StartCooking
	function self:StartCooking(...)
		if not inst.components.A_ACookpot then return oldfn(self,...) end
		local cpn_cp = inst.components.A_ACookpot
		local prefablist = {}
		if inst.components.container and inst.components.container:IsFull() then 
			for k,v in pairs(inst.components.container.slots) do
				prefablist[v.prefab] = 1+(prefablist[v.prefab] or 0)
			end
		end
		--真实材料
		if not inst:HasTag('A_Acasual_ing') then
			oldfn(self,...)
			cpn_cp:AddNewRecipe(prefablist,self.product)
			return
		end
		--虚拟材料
		local player = GetPlayer()
		local result = nil
		if cpn_cp:ShouldStart({player,getbackpack(player),getopenchest(player)}) then 
			cpn_cp:ClearCookpot()
			player.components.talker:Say(ST.A_Afor_dawdler.food.warning1)--('我 想 我 应 该 重 新 整 理 下 食 材')
			return
		end --填充后关闭背包或冰箱
		 --虚拟填充材料 重新检测是否可以填满锅  可以的话就删除容器中相应物品
		if cpn_cp:CanStuffCookpot(prefablist) then
			cpn_cp:RemoveItemsFromInvs(prefablist)
			result = oldfn(self,...)
		else --填充后把背包或箱子中材料放地上 或 拿起
			cpn_cp:ClearCookpot()
			player.components.talker:Say(ST.A_Afor_dawdler.food.warning2)--('好 坏 啊 你 ！  差 点 游 戏 就 崩 溃 了 ！')
			return
		end
		cpn_cp:AddNewRecipe(prefablist,self.product)
		return result --nil
	end
end
if PREDICT_FOOD then
	AddPrefabPostInit('cookpot',Pot_PI)
	AddPrefabPostInit('portablecookpot',Pot_PI)
	AddComponentPostInit('stewer',Stewer_PI)
end
--FOOD FOOD FOOD FOOD FOOD FOOD predict food FOOD FOOD FOOD FOOD FOOD FOOD FOOD FOOD FOOD-----------------------------------------------
--箱子的整理模式选择及百宝箱功能按钮 --ClassPostConstruct
local function CTN_PC(self) 
	self.A_Abutton = {}
--开锅盖
	local OldO = self.Open
    function self:Open(container, doer,...)
		OldO(self,container, doer,...)
	if isnormalchest(container) then
		local Spos = container.components.container.widgetslotpos
		if type(Spos)~='table' then print('container.components.container.widgetslotpos ~= type(table)') return end 
		local Wpos = Spos and ((#Spos % 2 == 0 and (Spos[#Spos/2] + Spos[#Spos/2 +1])/2)--双数取中间两个的中间位置
						or Spos[math.ceil(#Spos/2)] )--单数格子取中间 格子位置
		local cpn_con = container.components.container
		local cpn_edt = container.components.A_AEdit
		for k=1,2 do
			self.A_Abutton[k] = self:AddChild(ImageButton("images/ui.xml", "button_long_over.tex","button_long_disabled.tex"))
			local button = self.A_Abutton[k]
			button:SetScale(.66,.66,.66)
			button:SetFont(textfont) --BUTTONFONT
			button:SetTextSize(50)
			button:SetTextFocusColour(unpack(ST.A_AColours[4]))--(32/255,252/255,242/255,1)
			button:SetPosition(Vector3((k==1 and -1 or 1)*(Wpos.x - Spos[1].x + 100) + Wpos.x ,0, 0))
		end	
		
		    self.A_Abutton[1]:SetOnClick( function()
				local IsFridge = isfreezer(container) and not ispet(container)
				if TheInput:IsKeyDown(GLOBAL.KEY_CTRL) then
					cpn_con.Chest_Method = cpn_con.Chest_Method == CHEST_METHOD[1] and CHEST_METHOD[math.ceil(#CHEST_METHOD/2)] or CHEST_METHOD[1] 
				else
					local idx = 2
					local num = #CHEST_METHOD
					for i=1,num do
						if cpn_con.Chest_Method == CHEST_METHOD[i] then
							idx = i
							break
						end
					end
					if TheInput:IsKeyDown(GLOBAL.KEY_SHIFT) then				
						if IsFridge and cpn_con.Chest_Method == 'SELF' then
							idx = 9+1  --冰箱没必要那么多模式     9为CL_C
						end
						cpn_con.Chest_Method = CHEST_METHOD[idx <= 1 and num or idx-1]
					else
						if IsFridge and cpn_con.Chest_Method == 'CL_C' then
							idx = 0  --冰箱没必要那么多模式
						end
						cpn_con.Chest_Method = CHEST_METHOD[idx >= num and 1 or idx+1]				
					end
				end
				cpn_edt:UpdataString()
				self.A_Abutton[1]:SetText(cpn_edt.A_Astring)
			end )
		cpn_edt:UpdataString()
		self.A_Abutton[1]:SetText(cpn_edt.A_Astring)
		    self.A_Abutton[2]:SetOnClick( function()
				if TheInput:IsKeyDown(GLOBAL.KEY_CTRL) then
					if container.Label then
						cpn_edt.LBEnable = not cpn_edt.LBEnable
						container.Label:Enable(cpn_edt.LBEnable) 
					end
				else
					cpn_con.BAIBAO_CHEST = not cpn_con.BAIBAO_CHEST
					cpn_edt:UpdataString()
					self.A_Abutton[2]:SetText(cpn_con.BAIBAO_CHEST and ST.A_Afor_dawdler.sort.baibao or ST.A_Afor_dawdler.sort.normal)							
				end
			end )
		self.A_Abutton[2]:SetText(cpn_con.BAIBAO_CHEST and ST.A_Afor_dawdler.sort.baibao or ST.A_Afor_dawdler.sort.normal)
	-- FOOD FOOD FOOD FOOD FOOD FOOD predict food FOOD FOOD FOOD FOOD FOOD FOOD FOOD FOOD FOOD-----------------------------------------------
	elseif container.components.A_ACookpot then
		local function predict_food(button,productinfo)
			if not button then return end
			if button.item then button.item:Remove() button.item = nil end			
			if productinfo then 
				button.item = GLOBAL.SpawnPrefab(productinfo.name)
				if button.item then
					local stringinfo = container.components.A_ACookpot:GetStringInfo() or ''
					local stringinfo1 = ST.A_Afor_dawdler.food.page..(ST.NAMES[string.upper(productinfo.name)] or ST.A_Afor_dawdler.food.unknown)
					local stringinfo2 = ST.A_Afor_dawdler.food.chance..(productinfo.chance*100)..'%  |  '..ST.A_Afor_dawdler.food.product_spoilage..(productinfo.product_spoilage*100)..'%' 
					button:SetTextures(button.item.components.inventoryitem:GetAtlas(), button.item.components.inventoryitem:GetImage())
					button:SetText(stringinfo1..'\n'..stringinfo..'\n'..stringinfo2)
					return
				end
			end
			button:SetText(ST.A_Afor_dawdler.food.book_open)
			button:SetTextures("images/inventoryimages.xml", "waxwelljournal.tex") 
		end
		    self.A_Abutton[1] = self:AddChild(ImageButton("images/inventoryimages.xml", "waxwelljournal.tex"))
		    self.A_Abutton[1]:SetPosition(Vector3(0,220,0))
		    self.A_Abutton[1]:SetText(ST.A_Afor_dawdler.food.book_open)
		    self.A_Abutton[1]:SetFont(textfont) --BUTTONFONT
		    self.A_Abutton[1]:SetTextSize(40)
		    self.A_Abutton[1].text:SetPosition(0,100,0)
		    self.A_Abutton[1]:SetTextColour(unpack(ST.A_AColours[3]))--(72/255,  252/255,  32/255, 1)--(32/255,252/255,242/255,1)
		    self.A_Abutton[1]:SetTextFocusColour(unpack(ST.A_AColours[1]))--(252/255,  2/255,  102/255, 1)
		    self.A_Abutton[1]:SetOnClick( function()
				container.components.A_ACookpot:ClearCookpot()
		    end)
		     self.A_Abutton[2]= self.A_Abutton[1]:AddChild(ImageButton(GLOBAL.HUD_ATLAS, "turnarrow_icon.tex"))
		     self.A_Abutton[2]:SetScale(-.85,.85,.85)
		     self.A_Abutton[2]:SetPosition(-66,0,0)
		     self.A_Abutton[2]:SetOnClick( function()
				container.components.A_ACookpot:ClearCookpot()
				container.components.A_ACookpot:PreviousRecipe()
				container.components.A_ACookpot:StuffCookpot({doer,getbackpack(doer),getopenchest(doer)})
		     end)
		     self.A_Abutton[3]= self.A_Abutton[1]:AddChild(ImageButton(GLOBAL.HUD_ATLAS, "turnarrow_icon.tex"))
		     self.A_Abutton[3]:SetScale(.85,.85,.85)
		     self.A_Abutton[3]:SetPosition(66,0,0)
		     self.A_Abutton[3]:SetOnClick( function()
				container.components.A_ACookpot:ClearCookpot()
				container.components.A_ACookpot:NextRecipe()
				container.components.A_ACookpot:StuffCookpot({doer,getbackpack(doer),getopenchest(doer)})
		     end)
			--bg   --tab_science  tab_researchable  clock_rim  inv_slot  clock_wedge clock_NIGHT
		     self.A_Abutton[4]= self.A_Abutton[1]:AddChild(Image(GLOBAL.HUD_ATLAS, "tab_researchable.tex"))
		     self.A_Abutton[4]:SetScale(.63,.63,.63)
		     self.A_Abutton[4]:MoveToBack()
		 --food_method   
		self.A_Abutton.imagebutton = {}
		    local B_M = {
				--{atlasname = nil,imagename='powcake.tex',fn = function() A_AST.FOOD_TYPE = 'PERISH'  end},--新鲜度
				{atlasname = nil,imagename='bonestew.tex',fn = function() container.components.A_ACookpot:SetMethod('hunger') container.components.A_ACookpot.currentkey = 0 self.A_Abutton[3].onclick() end},--饱食度
				{atlasname = nil,imagename='dragonpie.tex',fn = function() container.components.A_ACookpot:SetMethod('health') container.components.A_ACookpot.currentkey = 0 self.A_Abutton[3].onclick() end},--血量
				{atlasname = nil,imagename='taffy.tex',fn = function() container.components.A_ACookpot:SetMethod('sanity') container.components.A_ACookpot.currentkey = 0 self.A_Abutton[3].onclick() end},--精神
			}
		    
		local function B_I_C(num)
			for k,v in ipairs(self.A_Abutton.imagebutton) do
				local cl = k == num and 1 or 0
				v.image:SetTint(cl,cl,cl,1)
			end
		end
		for k,v in ipairs(B_M) do
			self.A_Abutton.imagebutton[k] = self:AddChild(ImageButton((v['atlasname'] or 'images/inventoryimages.xml'), v['imagename'],v['imagename']))
			local button = self.A_Abutton.imagebutton[k]
			local pt = {-100,175,0}
			button.fn = v['fn']
			button:SetScale(.75,.75,.75)
			button:SetPosition(Vector3(pt[1],pt[2]-k*50,pt[3]))
			button:SetOnClick(function() if button.fn then button.fn() end B_I_C(k) end)
		end
		  local zhyx = {hunger = 1,health = 2,sanity = 3,}
		  B_I_C(zhyx[container.components.A_ACookpot:GetMethod()])
		--event
		--快速定位食谱按钮
		self.A_Abutton.textbutton = {}
		if not self.A_Atextbuttonchangefn then
			self.A_Atextbuttonchangefn = function()
				local names = {}
				for k,v in pairs(self.A_Abutton.textbutton) do
					if v then
						v:Kill()
						self.A_Abutton.textbutton[k]=nil
					end
				end
				local valid_recipes = container.components.A_ACookpot:GetValidRecipes()
				for k,v in ipairs(valid_recipes) do
					if not GLOBAL.table.contains(names,v.name) then
						table.insert(names,v.name)
					end
				end
				for i,foodname in ipairs(names) do
					self.A_Abutton.textbutton[i]= self:AddChild(TextButton())
					local button = self.A_Abutton.textbutton[i]
					local pt = {150,175,0}
					local size = i==1 and 36 or i==2 and 35 or i==3 and 34 or 33
					button:SetTextSize(size)
					button:SetFont(textfont)
					local cl = i==1 and ST.A_AColours[5] or i==2 and ST.A_AColours[6] or i==3 and ST.A_AColours[7] or ST.A_AColours[3]
					button:SetColour(unpack(cl))--(32/255,252/255,242/255,1)
					button:SetOverColour(unpack(ST.A_AColours[8]))--(255/255,20/255,147/255,1)--(252/255,  2/255,  102/255, 1)
					button:SetPosition(Vector3(pt[1],pt[2]-i*33,pt[3]))
					button:SetText(ST.NAMES[string.upper(foodname)] or 'unknown')
					button:SetOnClick(function()
						container.components.A_ACookpot:ToRecipes(foodname)
						container.components.A_ACookpot:ClearCookpot()
						container.components.A_ACookpot:StuffCookpot()
					end)
				end
			end
		end
		self.inst:ListenForEvent("permute_tx_bt", self.A_Atextbuttonchangefn, container)  
		if not self.A_Aonitemgetfn then
			self.A_Aonitemgetfn = function(container,data)
				local productinfo = container.components.A_ACookpot:GetProductInfo()
				if productinfo then
					predict_food(self.A_Abutton[1],productinfo)
				end
			end
		end
		self.inst:ListenForEvent("itemget", self.A_Aonitemgetfn, container)
		if not self.A_Aonitemlosefn then
			self.A_Aonitemlosefn = function(container)
				predict_food(self.A_Abutton[1],nil)
			end
		end
		self.inst:ListenForEvent("itemlose", self.A_Aonitemlosefn, container)
	    self.A_Aonitemgetfn(container)
	end
-- FOOD FOOD FOOD FOOD FOOD FOOD predict food FOOD FOOD FOOD FOOD FOOD FOOD FOOD FOOD FOOD-----------------------------------------------
    end
--盖锅盖    
	local OldC = self.Close
    function self:Close(...)
		local function killchildren(tb)
			for k,v in pairs(tb) do
				if type(k) == 'string' then
					killchildren(v)
				else
					v:Kill()
					tb[k]=nil
				end
			end
		end
		killchildren(self.A_Abutton)
		if self.A_Atextbuttonchangefn and self.container then
			self.inst:RemoveEventCallback("permute_tx_bt", self.A_Atextbuttonchangefn, self.container)
		end		
		if self.A_Aonitemgetfn and self.container then
			self.inst:RemoveEventCallback("itemget", self.A_Aonitemgetfn, self.container)
		end
		if self.A_Aonitemlosefn and self.container then
			self.inst:RemoveEventCallback("itemget", self.A_Aonitemlosefn, self.container)
		end
		if self.container and self.container.components.A_ACookpot then self.container.components.A_ACookpot:OnCookpotClose() end
	return OldC(self,...)
   end
end
AddClassPostConstruct ("widgets/containerwidget", CTN_PC)
--在物品栏中间加整理模式选择及开始整理按钮  --ClassPostConstruct
local function imagechange(self,walk,extra)
	local gg = (extra and walk) or (not extra and A_AST.STACK_FOOD) 
	self.image_normal =gg and 'button_checkbox2.tex' or  'button_checkbox1.tex' 
	self.image_focus = self.image_normal
	self.image:SetTexture(self.atlas, self.image_normal)
end
local function INV_BAR_PC(self)
	self.A_Abutton = {}
	--sort_button
	    self.A_Abutton[1] = self:AddChild(ImageButton("images/ui.xml", "button_long_over.tex","button_long_disabled.tex"))
	    self.A_Abutton[1]:SetPosition(Vector3(Sort_Button_Position[SORT_BUTTON_POSITION][1],Sort_Button_Position[SORT_BUTTON_POSITION][2], Sort_Button_Position[SORT_BUTTON_POSITION][3]))
	    self.A_Abutton[1]:SetScale(.66,.66,.66)
	    self.A_Abutton[1]:SetText(ST.A_Afor_dawdler.sort.sort) -- As the First Slot
	    self.A_Abutton[1]:SetFont(textfont)
	    self.A_Abutton[1]:SetTextSize(50)
	    self.A_Abutton[1].text:SetVAlign(GLOBAL.ANCHOR_MIDDLE)
	    self.A_Abutton[1]:SetTextFocusColour(unpack(ST.A_AColours[4]))--(32/255,252/255,242/255,1)
	    self.A_Abutton[1]:SetOnClick( function() SORT_NOW() end )
	 --food_method
	 self.A_Abutton.imagebutton = {}
	    local B_M = {
			{atlasname = nil,imagename='tophat.tex',fn = function()  A_AST.SORT_METHOD = not A_AST.SORT_METHOD end},--模式
			{atlasname = nil,imagename='powcake.tex',fn = function() A_AST.FOOD_TYPE = 'PERISH'  end},--新鲜度
			{atlasname = nil,imagename='bonestew.tex',fn = function() A_AST.FOOD_TYPE = 'HUNGER'  end},--饱食度
			{atlasname = nil,imagename='dragonpie.tex',fn = function() A_AST.FOOD_TYPE = 'HEALTH'  end},--血量
			{atlasname = nil,imagename='taffy.tex',fn = function() A_AST.FOOD_TYPE = 'SANITY'  end},--精神
		}
	    
	local function B_I_C(num)
		for k,v in ipairs(self.A_Abutton.imagebutton) do
			if num == 1 and k==1 then
				v.image_normal = A_AST.SORT_METHOD and 'tophat.tex' or 'strawhat.tex'--'flowerhat.tex'--'scarecrow.tex'
				v.image_focus = v.image_normal
				v.image:SetTexture(v.atlas, v.image_normal)
				break
			else
				local cl = (k==1 or k == num) and 1 or 0
				v.image:SetTint(cl,cl,cl,1)
			end
		end
	end
	    
	    for k,v in ipairs(B_M) do
		self.A_Abutton.imagebutton[k] = self:AddChild(ImageButton((v['atlasname'] or 'images/inventoryimages.xml'), v['imagename'],v['imagename']))
		local button = self.A_Abutton.imagebutton[k]
		local pt = Sort_Button_Position[SORT_BUTTON_POSITION]
		button.fn = v['fn']
		button:SetScale(.75,.75,.75)
		button:SetPosition(Vector3(pt[1]-150+k*50,pt[2] <1000 and pt[2]+40 or pt[2]-40,pt[3]))
		button:Hide()
		button:SetOnClick(function() if button.fn then button.fn() end B_I_C(k) end)
					
		local OldLL = button.OnLoseFocus
		button.OnLoseFocus = function()
			OldLL(button)
			if self.A_Abutton[1].focus then return end
			for k,v in ipairs(self.A_Abutton.imagebutton) do if v.focus then return end end
			for k,v in ipairs(self.A_Abutton.imagebutton) do v:Hide() end
		end
	   end
	  
	  B_I_C(2) --默认按新鲜度排序
	    
	--food_stack_button
	    self.A_Abutton[2] = self:AddChild(ImageButton("images/ui.xml","button_checkbox1.tex","button_checkbox2.tex"))
	    self.A_Abutton[2]:SetPosition(Vector3(Sort_Button_Position[SORT_BUTTON_POSITION][1]+77,Sort_Button_Position[SORT_BUTTON_POSITION][2]-5,Sort_Button_Position[SORT_BUTTON_POSITION][3]))
	    self.A_Abutton[2]:SetScale(.33,.33,.33)
	    self.A_Abutton[2]:SetOnClick( function()
		    A_AST.STACK_FOOD =not A_AST.STACK_FOOD
		    imagechange(self.A_Abutton[2])
	    end )
	     imagechange(self.A_Abutton[2])
--sort_button    OnGainFocus	OnLoseFocus
		local OldG = self.A_Abutton[1].OnGainFocus
		local OldL = self.A_Abutton[1].OnLoseFocus
	    self.A_Abutton[1].OnGainFocus = function()
			OldG(self.A_Abutton[1])
			for k,v in ipairs(self.A_Abutton.imagebutton) do v:Show() end
		end
	    self.A_Abutton[1].OnLoseFocus = function()
			OldL(self.A_Abutton[1])
			for k,v in ipairs(self.A_Abutton.imagebutton) do if v.focus then return end end
			for k,v in ipairs(self.A_Abutton.imagebutton) do v:Hide() end
		end
	
	--auto_walk_button   --偷懒用的
	if PLAYER_FOLLOW_MOUSE then
		local key = {
			GLOBAL.KEY_F,	GLOBAL.KEY_W,
			GLOBAL.KEY_S,	GLOBAL.KEY_A, -----4
			GLOBAL.KEY_D,	GetModConfigData("PLAYER FOLLOW MOUSE"),
		}
	
		if not self.A_Abutton[3] then
				local player = self.owner
			self.A_Abutton[3] = self:AddChild(ImageButton("images/ui.xml","button_checkbox1.tex","button_checkbox2.tex"))
			self.A_Abutton[3]:SetPosition(Vector3(Sort_Button_Position[SORT_BUTTON_POSITION][1]-77,Sort_Button_Position[SORT_BUTTON_POSITION][2]-5, Sort_Button_Position[SORT_BUTTON_POSITION][3]))
			self.A_Abutton[3]:SetScale(.33,.33,.33)
			self.A_Abutton[3]:SetOnClick( function()
				if player.auto_walk then
					player.auto_walk:Cancel()
					player.auto_walk = nil
					if not player.components.locomotor.bufferedaction or not player.bufferedaction then --IsValid() --player.bufferedaction
						player.components.locomotor:Stop()
					end
				else
					player.auto_walk = player:DoPeriodicTask(.25,function()
						if TheInput:IsMouseDown(GLOBAL.MOUSEBUTTON_RIGHT) then
							if player.components.locomotor.isrunning and not player.components.locomotor.bufferedaction and not player.bufferedaction then
								player.components.locomotor:Stop()
							end
							return
						end
						local ishud = TheInput:GetHUDEntityUnderMouse() or getopenchest(player)
						if ishud then return end
						local pt = Vector3(player.Transform:GetWorldPosition())
						local pos = TheInput:GetWorldPosition()
						local right_direction = pos and math.sqrt(math.pow((pt.x-pos.x),2) + math.pow((pt.z-pos.z) ,2)) > 2.5
						local canwalk = right_direction and not player.components.locomotor.bufferedaction and not player.bufferedaction 
						local forcewalking = TheInput:IsKeyDown(key[2]) or TheInput:IsKeyDown(key[3]) or TheInput:IsKeyDown(key[4]) or TheInput:IsKeyDown(key[5]) or TheInput:IsKeyDown(GLOBAL.KEY_SPACE) --working  Haha
						if pos and canwalk and not forcewalking then
							player.components.locomotor:GoToPoint(GLOBAL.Point(pos.x, pos.y, pos.z),nil,true)
						end
					end)
				end
				imagechange(self.A_Abutton[3],player.auto_walk,'extra')
			end )
		imagechange(self.A_Abutton[3],player.auto_walk,'extra')
		end
		for k = 1, #key do
			TheInput:AddKeyUpHandler(key[k],function()
				local shouldstart = k == 6
				local shouldstop = GetPlayer().auto_walk
				if self.A_Abutton[3] and isKeyDown(nil,true) and (shouldstart or shouldstop) then
					self.A_Abutton[3].onclick()
				end
			end)
		end
	end
end
AddClassPostConstruct ("widgets/inventorybar", INV_BAR_PC)
--按照物品信息分类  （一般好的都放表的后面）	2
local function sort_table(TABLE,player)
	local sort_fn = {}
	sort_fn.Weapon = function(a,b)
		if (a.components.weapon.damage or 0) == (b.components.weapon.damage or 0) then
			if (a.components.finiteuses and a.components.finiteuses.current or 0) == (b.components.finiteuses and b.components.finiteuses.current or 0) then
				return a.prefab > b.prefab
			else
				return (a.components.finiteuses and a.components.finiteuses.current or 0) < (b.components.finiteuses and b.components.finiteuses.current or 0)
			end
		else
			return a.components.weapon.damage < b.components.weapon.damage 
		end
	end
	sort_fn.Armor = function(a,b)
		if (a.components.armor.absorb_percent or 0) == (b.components.armor.absorb_percent or 0) then
			if (a.components.armor:GetPercent() or 0) == (b.components.armor:GetPercent() or 0) then
				return a.prefab > b.prefab
			else
				return  (a.components.armor:GetPercent() or 0) <  (b.components.armor:GetPercent() or 0)
			end
		else
			return a.components.armor.absorb_percent < b.components.armor.absorb_percent 
		end
	end
	sort_fn.Tool = function(a,b)
		if (a.components.tool and a.components.tool.action or 'a') == (b.components.tool and b.components.tool.action or 'b') then
			if (a.components.finiteuses and a.components.finiteuses.current or 0) == (b.components.finiteuses and b.components.finiteuses.current or 0) then
				return a.prefab > b.prefab
			else
				return (a.components.finiteuses and a.components.finiteuses.current or 0) < (b.components.finiteuses and b.components.finiteuses.current or 0)
			end
		else
			return a.prefab > b.prefab
		end
	end
	sort_fn.Light = function(a,b)
		if a.prefab == b.prefab then 
			return (a.components.fueled and a.components.fueled.currentfuel or 0) < (b.components.fueled and b.components.fueled.currentfuel or 0)
		else
			return a.prefab > b.prefab
		end
	end
	sort_fn.Clothing = function(a,b)
		if a.prefab == b.prefab then 
			return (a.components.fueled and a.components.fueled.currentfuel or 0) < (b.components.fueled and b.components.fueled.currentfuel or 0)
		else
			return a.prefab > b.prefab
		end
	end
	sort_fn.Food_HUNGER = function(a,b)
		if (a.components.edible:GetHunger(player) or 0) == (b.components.edible:GetHunger(player) or 0) then
			return a.prefab > b.prefab
		else
			return (a.components.edible:GetHunger(player) or 0) < (b.components.edible:GetHunger(player) or 0)
		end
	end	
	sort_fn.Food_HEALTH = function(a,b)
		if (a.components.edible:GetHealth(player) or 0) == (b.components.edible:GetHealth(player) or 0) then
			return a.prefab > b.prefab
		else
			return (a.components.edible:GetHealth(player) or 0) < (b.components.edible:GetHealth(player) or 0)
		end
	end
	sort_fn.Food_SANITY = function(a,b)
		if (a.components.edible:GetSanity(player) or 0) == (b.components.edible:GetSanity(player) or 0) then
			return a.prefab > b.prefab
		else
			return (a.components.edible:GetSanity(player) or 0) < (b.components.edible:GetSanity(player) or 0)
		end
	end
	sort_fn.Food_PERISH = function(a,b)
		if (a.components.perishable and a.components.perishable:GetPercent() or 0) == (b.components.perishable and b.components.perishable:GetPercent() or 0) then
			return a.prefab > b.prefab
		else
			return (a.components.perishable and a.components.perishable:GetPercent() or 0) < (b.components.perishable and b.components.perishable:GetPercent() or 0)
		end
	end
	sort_fn.Others = function(a,b)
		if A_AST.CustomItems[a.prefab] and A_AST.CustomItems[b.prefab] then
			if a.prefab == b.prefab then
				return (a.components.stackable and a.components.stackable.stacksize or 0) > (b.components.stackable and b.components.stackable.stacksize or 0) 
			else
				return a.prefab > b.prefab
			end
		elseif A_AST.CustomItems[a.prefab] then
			return false
		elseif A_AST.CustomItems[b.prefab] then
			return true
		else
			if a.prefab == b.prefab then
				return (a.components.stackable and a.components.stackable.stacksize or 0) < (b.components.stackable and b.components.stackable.stacksize or 0) 
			else
				return a.prefab > b.prefab -- z~a
			end
		end
	end
	for k,v in pairs(TABLE) do
		k = sort_fn[k] and k or k..'_'..A_AST.FOOD_TYPE
		table.sort(v,sort_fn[k])
	end
end
 -- 整理好的物品放入箱子中 好的都放前边吧	3
local function chest_sort(Table,Chest,Index,Same,FoodType)
	if Table then
		for k = #Table, 1, -1 do  --排序：由好到次
			local normal = Table[k]
			if FoodType and normal then
				if (FoodType ==  'COOKED' and (cooking.IsCookingIngredient(normal.prefab) or normal.components.fuel or normal.components.edible.foodtype == 'SEEDS' )) --去掉花瓣，可燃烧
					or (FoodType ==  'INGREDIENT' and not cooking.IsCookingIngredient(normal.prefab))
					or (FoodType == 'MEAT' and normal.prefab ~='ice'
										and normal.prefab ~='goatmilk'
										and normal.components.edible.foodtype ~= 'MEAT') 
					or (FoodType == 'SEEDS' and normal.prefab ~='ice'
										and not normal.components.fuel  --花瓣  荧光果  虫灯 可以放入种子箱
										and normal.components.edible.foodtype ~= 'SEEDS')
					or (FoodType == 'VEGGIE' and normal.prefab ~='ice' 
										and normal.prefab ~='butter' 
										and normal.prefab ~='honey' 
										and normal.components.edible.foodtype ~= 'VEGGIE') 
					then
					normal = nil
				end
			end
			local is_pet_bone = normal and normal.components.leader
			if normal and not is_pet_bone and Chest.components.container:CanTakeItemInSlot(normal, Index) then  --下边一行长长的括号里边的句子意思：在只整理箱子外 的其他模式下，特定的物品如果没有堆叠满则不会放入箱子
				if not Chest.components.container:IsFull() and (Chest.components.container.Chest_Method == 'SELF' 
												or (Chest.components.container.Chest_Method == 'FIRST_SLOT' 
													and normal.prefab ~= 'cutgrass' and normal.prefab ~= 'twigs' and normal.prefab ~= 'log' )
												or (not A_AST.CustomItems or (not A_AST.CustomItems[normal.prefab] or  (not normal.components.stackable or normal.components.stackable.stacksize == normal.components.stackable.maxsize))))then
					if Same then
						if Same[normal.prefab] then
							Chest.components.container:GiveItem(normal, Index, nil,false,true)
							Index = Index + 1
							table.remove(Table,k)
						end
					else
						Chest.components.container:GiveItem(normal, Index, nil,false,true)
						Index = Index + 1
						table.remove(Table,k)
					end
				end
			end
		end
	end
end
--整理好的东西放在身上或背包里	4
local function Pack_Is_Full(Pack)
	local maxnum = Pack.components.container.numslots - PACK_FREE_SLOTS
	local items = 0
	for k = 1,maxnum do
		if Pack.components.container.slots[k] then
			items = items + 1
		end
	end
	return items >= maxnum
end
local function canputinfreeslot(Player)
	for k=1,FREE_SLOTS do
		if not Player.components.inventory.itemslots[k] then return true end
	end
	return false
end
local function player_inv_pack_sort(Table,Player,Pack,Index,Method,PLAYER_INVS,Fight)
	local Is_BM = Method or Fight --best method
	local fn = {}
	fn.Weapon =  function(normal,spc)
		if spc then
			Player.components.inventory:GiveItem(normal,PLAYER_INVS-1,nil,true)
		elseif Pack and not Fight and not Pack_Is_Full(Pack) then
			Pack.components.container:GiveItem(normal,nil,nil,false,true) --其他有背包放背包
		else
			Player.components.inventory:GiveItem(normal,Index,nil,true) --无背包放身上
			Index = Index+1
		end
	end
	fn.Armor =  function(normal,spc)
		if spc then
			Player.components.inventory:GiveItem(normal,PLAYER_INVS,nil,true)
		elseif Pack and not Fight and not Pack_Is_Full(Pack) then
			Pack.components.container:GiveItem(normal,nil,nil,false,true) --其他有背包放背包
		else
			Player.components.inventory:GiveItem(normal,Index,nil,true) --无背包放身上
			Index = Index+1
		end
	end
	fn.Tool =  function(normal,spc)
		if spc and Player.components.inventory.itemslots[PLAYER_INVS-1] == nil then
			Player.components.inventory:GiveItem(normal,PLAYER_INVS-1,nil,true)
		elseif Pack and not Pack_Is_Full(Pack) then
			Pack.components.container:GiveItem(normal,nil,nil,false,true) --其他有背包放背包
		else
			Player.components.inventory:GiveItem(normal,Index,nil,true) --无背包放身上
			Index = Index+1
		end
	end	
	fn.Light =  function(normal,spc)
		local lightslot = FREE_SLOTS+1
		if Player.components.inventory.itemslots[lightslot] == nil then
			Player.components.inventory:GiveItem(normal,lightslot,nil,true)
			Index = Index == lightslot and Index+1 or Index
		elseif Pack and not Fight and not Pack_Is_Full(Pack) then
			Pack.components.container:GiveItem(normal,nil,nil,false,true) --其他有背包放背包
		else
			Player.components.inventory:GiveItem(normal,Index,nil,true) --无背包放身上
			Index = Index+1
		end
	end
	fn.Clothing =  function(normal,spc)
		if normal.prefab == 'cane' and canputinfreeslot(Player) then
			Player.components.inventory:GiveItem(normal,1,nil,true)
		elseif Player.components.inventory.itemslots[PLAYER_INVS] == nil then
			Player.components.inventory:GiveItem(normal,PLAYER_INVS,nil,true)
		elseif Pack and not Pack_Is_Full(Pack) then
			Pack.components.container:GiveItem(normal,nil,nil,false,true) --其他有背包放背包
		else
			Player.components.inventory:GiveItem(normal,Index,nil,true) --无背包放身上
			Index = Index+1
		end
	end
	fn.Food =  function(normal,spc)
		if Pack and not Fight and not Pack_Is_Full(Pack) then
			Pack.components.container:GiveItem(normal,nil,nil,false,true) --其他有背包放背包
		else
			Player.components.inventory:GiveItem(normal,Index,nil,true) --无背包放身上
			Index = Index+1
		end
	end
	local dontputinbag_fight = { 'bandage','healingsalve','heatrock'}
	fn.Others = function(normal,spc)--下面一句话：是特定物品的话要叠加满才放背包，其他优先放背包
		local iscustom = A_AST.CustomItems[normal.prefab]
		local iscustom_maxsize = iscustom and (not normal.components.stackable or normal.components.stackable.stacksize == normal.components.stackable.maxsize)
		if (normal.components.leader or normal.prefab == 'heatrock') and canputinfreeslot(Player) then
			Player.components.inventory:GiveItem(normal,1,nil,true)
		elseif Pack and (not Fight or not GLOBAL.table.contains(dontputinbag_fight,normal.prefab)) and not Pack_Is_Full(Pack) and (not iscustom or (iscustom_maxsize and Player.components.inventory.itemslots[iscustom])) then
			Pack.components.container:GiveItem(normal,nil,nil,false,true) --其他有背包放背包 不满的也放身上
		else--下面一句话：可以放入特殊物品栏的是：特殊物品+ 不可叠加 或 未叠加满 或 叠加满且特殊物品栏上还没有物品
			if iscustom and (not normal.components.stackable or (normal.components.stackable.stacksize ~= normal.components.stackable.maxsize or  Player.components.inventory.itemslots[iscustom] == nil )) then
				Player.components.inventory:GiveItem(normal,iscustom,nil,true)
			else
				Player.components.inventory:GiveItem(normal,Index,nil,true)
				Index = Index+1
			end
		end
	end	
	local order = {'Weapon','Armor','Tool','Light','Clothing','Food','Others',}
	for i=1,#order do
		local v = Table[order[i]]
		if v then
			local a = (Is_BM or order[i]=='Others') and #v or 1
			local b = (Is_BM or order[i]=='Others') and 1 or #v
			local c = (Is_BM or order[i]=='Others') and -1 or 1
			for k = a,b,c do
				fn[order[i]](v[k],k==a)
			end
		end
	end
end
--开始整理	1
Sort_Inv = function(player,Fight) 
	local backpack = getbackpack(player)
	local backpack_size = backpack and math.max(backpack.components.container.numslots - PACK_FREE_SLOTS,0) or 0
	backpack = backpack_size > 0 and backpack or nil
	local chest = getopenchest(player)
	
	local MIN = FREE_SLOTS
	local PLAYER_INVS = player.components.inventory.maxslots
	local MAX = PLAYER_INVS + backpack_size

	local TB = {Weapon = {}, Armor = {}, Tool = {}, Light = {}, Clothing = {}, Food = {}, Others = {},}

	if A_AST.CustomItems.PLAYER_INVS ~= PLAYER_INVS then
		for k,i in pairs(A_AST.CustomItems) do
			A_AST.CustomItems[k] = PLAYER_INVS - i + 1
		end
		A_AST.CustomItems.PLAYER_INVS = PLAYER_INVS	
	end
	
local function presort(c,i)
	local self = c:A_AGetItemInfo(i)
	if self then
		local gone = nil
		if self.inst.components.stackable and (self.Type ~= 'Food' or A_AST.STACK_FOOD) then
			for k,v in pairs(TB[self.Type]) do
				if self.inst.prefab == v.prefab then
					gone = combine_stacks(v, self.inst)
				end
			end		
		end
		if not gone then
			table.insert(TB[self.Type],self.inst)
		end
		c:RemoveItemBySlot(i)
	end
end	
	--整理身上的东西
if not chest or chest.components.container.Chest_Method ~= 'SELF' then
	for i = MIN+1, MAX do
		if i > PLAYER_INVS then
			presort(backpack.components.container,i-PLAYER_INVS)
		else
			presort(player.components.inventory,i)
		end
	end
end
	--整理箱子里的东西
	local CHEST_SLOTS =chest and chest.components.container.numslots
	local Chest_Method =chest and chest.components.container.Chest_Method
	local start_slot = Chest_Method == 'FIRST_SLOT' and 2 or 1    --start_slot==2 => 相同的东西才可以放入
	local the_same_item = start_slot == 2 and chest.components.container.slots[1] and {[chest.components.container.slots[1].prefab] = 1} --确定物品的箱子 且 第一个确定物品类型不为空
if chest then
	if start_slot ~= 2 and (Chest_Method == 'ALL_SLOTS' 
					or (chest.components.container.BAIBAO_CHEST and Chest_Method ~= 'SELF' )) then --确定箱子里面的物品
		the_same_item = {}
		for key = 1,CHEST_SLOTS do
			if chest.components.container.slots[key] and not the_same_item[chest.components.container.slots[key].prefab] then
				the_same_item[chest.components.container.slots[key].prefab] = 1
			end
		end
	end
	for i = start_slot, CHEST_SLOTS do --用第一格来确定这个箱子放的东西种类
		presort(chest.components.container,i)
	end
end

sort_table(TB,player)
-------	-----------------------------还原------------------------------------
-------	-----------------------------还原------------------------------------	
	--先还原箱子里面的
if chest then
	local index = start_slot
	local IsFridge = isfreezer(chest) and not ispet(chest)--chest:HasTag('fridge') and not chest.components.locomotor
	local IsPet = ispet(chest)
	local select_fn ={
		OT_C = {	{tb = TB.Food,fn = function() return IsFridge or IsPet end,},
				{tb = TB.Others,fn = function() return true end},--暖石可放入食物箱
			},
		WE_C = {	{tb = TB.Food,fn = function() return IsFridge end,foodtype = 'COOKED'},
				{tb = TB.Weapon},
			},	
		AR_C = {	{tb = TB.Food,fn = function() return IsFridge end,foodtype = 'SEEDS'},
				{tb = TB.Armor},
			},	
		TO_C = {	{tb = TB.Food,fn = function() return IsFridge end,foodtype = 'MEAT'},
				{tb = TB.Tool},
			},	
		LI_C = {	{tb = TB.Food,fn = function() return IsFridge end,foodtype = 'VEGGIE'},
				{tb = TB.Light},
			},
		CL_C = {	{tb = TB.Food,fn = function() return IsFridge end,foodtype = 'INGREDIENT'},
				{tb = TB.Clothing},
			},
		EQ_C = {	{tb = TB.Weapon},{tb = TB.Armor},{tb = TB.Tool},{tb = TB.Clothing},--{tb = TB.Light},
			},
		U_U = {	{tb = TB.Food,fn = function() return IsFridge or IsPet end,},
				{tb = TB.Weapon},{tb = TB.Armor},{tb = TB.Tool},{tb = TB.Light},{tb = TB.Clothing},{tb = TB.Others},
			},
	}
	local ttbb = select_fn[Chest_Method] or select_fn['U_U']
	for k,v in ipairs(ttbb) do
		if (not v.fn and not IsFridge) or (v.fn and v.fn()) then
			chest_sort(v.tb,chest,index,the_same_item,v.foodtype)
		end
	end
end
	--还原角色身上的和背包里的
	local index = MIN+1
		player_inv_pack_sort(TB,player,backpack,index,A_AST.SORT_METHOD,PLAYER_INVS,Fight)
end

function SORT_NOW()
	if isKeyDown(nil,true) then
		Sort_Inv(GetPlayer())
	elseif isKeyDown(GLOBAL.KEY_CTRL,true) then
		Sort_Inv(GetPlayer(),'Fight')
	end
end
TheInput:AddKeyUpHandler(SORT_KEY, SORT_NOW)