local SignScreen 	= require "screens/A_AEdit_Screen"
local ST = STRINGS
--local LABEL_POS = {.1,.2,.3,.4,.5,.7,.9,1.1,1.3,1.5,1.7,1.9,2.1,2.3,2.5}
--local LABEL_SIZE = {15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30}

local function onextinguish(inst)
--print('KillSelf   burn',inst)
	if inst and not inst:HasTag('burnable') then if inst.components.A_AEdit then inst.components.A_AEdit:KillSelf() end end 
end
local function isburnt(inst)
	if not inst.components.burnable and not inst:HasTag('burnt') then
		return false
	elseif inst:HasTag('burnable') then
		inst:ListenForEvent('onextinguish',onextinguish)
		return false
	elseif inst:HasTag('burnt') then
		return true
	end	
	return true
end


local A_AEdit = Class(function(self, inst)
	self.inst = inst
	self.edit_ = false
	self.type = nil
	self.A_AEdit_Str = nil
	self.A_Astring = ST.A_Afor_dawdler.sort.chest
	self.SignPlusFn = not is_Sign_Plugs_mod_enabled
end)

--type: Other  OtherContainer  Container  Fridge  Pet
function A_AEdit:IsComponentType(type)
	self.type = type
	if isburnt(self.inst) then self.type = 'OtherContainer' end
--print(type,self.inst)
	local fn = {
		OtherContainer = self.KillSelf,
		Other = self.SetSimpleComponent,
		Container = self.SetContainerComponent,
		Fridge = self.SetContainerComponent,
		Pet = self.SetPetComponent,
	}
	fn[self.type or 'OtherContainer'](self)
end
function A_AEdit:OnSave()
end
function A_AEdit:OnLoad(data)
	if data then
		self.A_AEdit_Str = data.str
			self.LBEnable = data.LBEnable
			self.LABEL_POS = data.LABEL_POS
			self.LABEL_SIZE = data.LABEL_SIZE
			self.LABEL_FONT = data.LABEL_FONT
			self.SNOW_COLOUR = data.SNOW_COLOUR
			self.COLOUR = data.COLOUR
	end		
end
function A_AEdit:KillSelf()
	local inst = self.inst
--print('KillSelf',inst)
	if self.snowcoverchangefn then
		inst:RemoveEventCallback('snowcoverchange',self.snowcoverchangefn,GetWorld())
	end 
	if inst.Label then inst.Label:Enable(false) end
	inst:RemoveComponent('A_AEdit')
end
function A_AEdit:SetContainerComponent()
	
	self.LBEnable = self.LBEnable == nil or self.LBEnable
	self.LABEL_POS = self.LABEL_POS or .3
	self.LABEL_SIZE = self.LABEL_SIZE or 19
	self.LABEL_FONT = self.LABEL_FONT or A_A_TEXTFONT_LAN or BODYTEXTFONT
	self.SNOW_COLOUR = self.SNOW_COLOUR or 3
	self.COLOUR = self.COLOUR or #ST.A_AColours
	if self.SignPlusFn then
		self.snowcoverchangefn = function(forest,data)
		--print('snowcoverchange',self.inst)
			if data and data.snow then self:UpdataLabel() end
		end
		self.inst:ListenForEvent('snowcoverchange',self.snowcoverchangefn,GetWorld())	
	end	
	self:UpdataString()
	
	self.OnSave = function()
		return
		{
			str = self.A_AEdit_Str,--str 
				LBEnable = self.LBEnable,--bl
				LABEL_POS = self.LABEL_POS,--num
				LABEL_SIZE = self.LABEL_SIZE,--num
				LABEL_FONT = self.LABEL_FONT,--str
				SNOW_COLOUR = self.SNOW_COLOUR,--num
				COLOUR = self.COLOUR,	--num
		}
	end
end
function A_AEdit:SetSimpleComponent()
	if self.SignPlusFn then
		self.OnSave = function() return { str = self.A_AEdit_Str,} end
		self.UpdataString = function() return end
		self.UpdataLabel = function() return end
	else
		self:KillSelf()
	end
end
function A_AEdit:SetPetComponent()
--print('Pet',self.inst)
	self.OnSave = function() return {str = self.A_AEdit_Str,} end
	self.UpdataLabel = function() return end
	self.CollectSceneActions = function() return end
end
function A_AEdit:UpdataString()
	local inst = self.inst
	local cpn_ctn = inst.components.container
	if not cpn_ctn then return end
	local Chest_Method = cpn_ctn.Chest_Method
	local BAIBAO_CHEST = cpn_ctn.BAIBAO_CHEST
	
	local df_str = ST.A_Afor_dawdler.sort[Chest_Method] or 'Failed to load' --防止原来的版本loading出错，因为原来不是用这样的string表示模式的，所以'Failed to load' 只有在用了原版的mod才会出现一次
	local str_fridge = self.type == 'Fridge' and ST.A_Afor_dawdler.sort[(Chest_Method)..'_FRIDGE']
	local str_pet = self.type == 'Pet' and ST.A_Afor_dawdler.sort[(Chest_Method)..'_PET']	
	local str_item_name = Chest_Method == 'FIRST_SLOT' and cpn_ctn.slots[1] and ST.NAMES[string.upper(cpn_ctn.slots[1].prefab)]
	local str_edit = (Chest_Method == 'ALL_SLOTS' or BAIBAO_CHEST) and self:GetString()
	local str_signdata = Chest_Method == 'ALL_SLOTS' and inst.components.signdata and inst.components.signdata.data and inst.components.signdata.data.str ~= nil and inst.components.signdata.data.str ~= '' and inst.components.signdata.data.str
	--兼容signplus mod 更改
	self.A_Astring =str_signdata or str_edit or str_item_name or str_pet or str_fridge or df_str 

	--Add label
	local L = inst.Label
	if not L then
		L = self.SignPlusFn and self.type ~= 'Pet' and inst.entity:AddLabel()
	end
	self:UpdataLabel()
end
function A_AEdit:UpdataLabel(str)
	local L = self.inst.Label
	if not L or not self.SignPlusFn then return end
	L:SetPos(.2,self.LABEL_POS,-.5)
	L:SetFontSize(self.LABEL_SIZE)
	L:SetFont(self.LABEL_FONT)
	L:Enable(self.LBEnable)
	local snow = GetSeasonManager() and GetSeasonManager().ground_snow_level>SNOW_THRESH or false 
	local cl = snow and ST.A_AColours[self.SNOW_COLOUR] or ST.A_AColours[self.COLOUR]
	L:SetColour(unpack(cl or ST.A_AColours[#ST.A_AColours]))
	L:SetText(str or self.A_Astring)
end
function A_AEdit:OnRightClick(tar)
	self.edit_ = true
	TheFrontEnd:PushScreen(SignScreen(tar))
end
function A_AEdit:SetString(str)
	self.A_AEdit_Str = str
end
function A_AEdit:GetString()
	return self.A_AEdit_Str
end

function A_AEdit:CollectSceneActions(doer, actions, right)
	if right and not self.edit_ then
		ST.ACTIONS.A_AEdit = ((not self.inst.components.container or (self.inst.components.container.BAIBAO_CHEST or self.inst.components.container.Chest_Method == 'ALL_SLOTS'))
								and self.A_AEdit_Str ~= '' and self.A_AEdit_Str)
							or ST.A_AEdit

		table.insert(actions, ACTIONS.A_AEdit)
	end
end

return A_AEdit