local assets = 
{
}
local prefab = 
{
}

local function onhammered(inst, worker)
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")

	inst:Remove()
end

local function getstatus(inst, viewer)
	if Input:IsKeyDown(KEY_CTRL) then
		onhammered(inst)
	elseif not inst.placer then
		inst.placer = SpawnPrefab('firesuppressor_placer')
		inst.placer.Transform:SetPosition(inst:GetPosition():Get())
		inst.placer.AnimState:SetAddColour(.25, .75, .25 ,0)
		inst.placer:DoTaskInTime(45,function() if inst.placer then inst.placer:Remove() inst.placer = nil end end)
	else
		inst.placer:Remove()
		inst.placer = nil
	end
end

local function onbuilt(inst)
	inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("idle_off")
	inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/craftable/firesupressor")
	--MakeObstaclePhysics(inst, 0)
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()

	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetPriority( 5 )
	minimap:SetIcon( "firesuppressor.png" )

	--MakeObstaclePhysics(inst, 1)

	anim:SetBank("firefighter")
	anim:SetBuild("firefighter")
	anim:PlayAnimation("idle_off")
	
	anim:SetMultColour(.25, .75, .25 ,0)
	
	inst:AddComponent("inspectable")
	inst.components.inspectable.getstatus = getstatus

	inst.AnimState:OverrideSymbol("swap_meter", "firefighter_meter", 5)

	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst.components.workable:SetWorkLeft(1)
	inst.components.workable:SetOnFinishCallback(onhammered)

	inst:ListenForEvent( "onbuilt", onbuilt)

	return inst
end

return Prefab("dummy_firesuppressor", fn, assets, prefabs)
--MakePlacer( "common/dummy_firesuppressor_placer", "firefighter_placement", "firefighter_placement", "idle", true, nil, nil, 1.55)
