require "util"

--local Button = require "widgets/button"
--local AnimButton = require "widgets/animbutton"
--local UIAnim = require "widgets/uianim"
--local NumericSpinner = require "widgets/numericspinner"
local Grid = require "widgets/grid"
local Spinner = require "widgets/spinner"
local Screen = require "widgets/screen"
local TextEdit = require "widgets/textedit"
local TextButton = require "widgets/textbutton"
local Widget = require "widgets/widget"
local Image = require "widgets/image"

local ST = STRINGS

local VALID_CHARS = [[ abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,:;[]\@!#$%&()'*+-/=?^_{|}~"һҲʱΪ˵žǺҪҲԻҿ¶ȥܶСȻѧô֮ÿ𷢵ûֻ°ѻõֿܴ鼺ŮǰЩͬ⶯ͷλְܸ˹֪ʲʹ߱˻мļ⺢߽ʮʵȫÿ̫±Ȳű鲿ˮ۵ȴӵٿ˴Աȿд׻סɫǴĸӦֱֳƽѹطϽӸЦӢζɽ·б߷νԭͨʦʧսԶʿĿزʼҵ˼ƬǮԪϲɿԸԼָϷظ۽ҽ˼ԺƷǾ˾δһ̨ҹ౱ӾúԽ価Ӱְܰʶϣа̸ݼ׸ʽȡհǿʯŻՠüװ˫ת׳վڿͳϸǹѡάϵʾԸǧʷ˭׼ͻ־ʫʹ徹ȷ赥οٽ¹ëϢٴγ̺žӿͻƤķѵͼ߸ϸרڿζľݰʳԴעĳѪϰУĬ΢Իϵ͠иδΰ˳ӡֽ֤ͣ۷Ȥ֧贺÷ľаյ˯չȺʶμͥлܵ񺦲űֹݳ⾦ǿæʺƾΧ׻侯ѩ簡ֵﺺųɳֲݻٹʥñ¶԰ţýҹóĪ챧Ȩ³̬ƱѰɱʤ󷶴¥׷ְ¼˿иǳҶžٲصϷҩҿɭƹ洰ɢ;ܶͶ׸ѹϴɺϾű״ҾϯͯũҰĠʵƾ⻷ķ̲ȱŷ㸶ݶίӵ̽ѽӪҡŪŵƽ׿ſ񺰽ЬģܰػʲƹǹֻܼˠǸ̹ƽ˳˻ڹԤʢͽ]]

local A_AEdit_Screen = Class(Screen, function(self,inst)
	Screen._ctor(self, "A_AEdit_Screen")
	SetPause(true,"pause")
	--inst.AnimState:SetMultColour(.25, .75, .25 ,1)
	
	local label_width = 200
	local label_height = 50
	local label_offset = 450

	local space_between = 30
	local height_offset = -270

	local fontsize = 30

	local edit_width = 180
	local edit_bg_padding = 100
	
	self.cpn_edt = inst.components.A_AEdit

	self.root = self:AddChild(Widget('ROOT'))
	self.root:SetVAnchor(ANCHOR_MIDDLE)
	self.root:SetHAnchor(ANCHOR_LEFT)
	self.root:SetScaleMode(SCALEMODE_PROPORTIONAL)
	self.root:SetPosition(400,50,0)
	
	self.shield = self.root:AddChild( Image( "images/globalpanels.xml", "small_dialog.tex" ) )
	self.shield:SetPosition( -5,0,0 )
	self.shield:SetSize( 330, 150 )

	self.edit_bg = self.root:AddChild(Image())
	self.edit_bg:SetTexture( "images/ui.xml", "textbox_short.tex")
	self.edit_bg:SetPosition( 0,0,0)
	self.edit_bg:ScaleToSize( edit_width + edit_bg_padding, label_height )

	--self.console_edit = self.root:AddChild( TextEdit( BODYTEXTFONT, 30, self.cpn_edt.A_AEdit_Str or inst.components.container and STRINGS.A_Afor_dawdler.sort['ALL_SLOTS'] or "" ) ) --inst.A_AEdit_Str or
	self.console_edit = self.root:AddChild( TextEdit( BODYTEXTFONT, 30, (inst.components.container and self.cpn_edt.A_Astring) or self.cpn_edt.A_AEdit_Str or ''))
	self.console_edit:SetPosition( 0,0,0)
	self.console_edit:SetRegionSize(edit_width, label_height)
	self.console_edit:SetHAlign(ANCHOR_LEFT)
	self.console_edit:SetFocusedImage( self.edit_bg, "images/ui.xml", "textbox_short_over.tex", "textbox_short.tex" )
	self.console_edit:SetTextLengthLimit(60)
	self.console_edit:SetCharacterFilter(VALID_CHARS)
	self.console_edit.OnTextEntered = function() self:OnTextEntered() end

	self.okbutton = self.root:AddChild(TextButton())
	self.okbutton:SetTextSize(30)
	self.okbutton:SetFont(DIALOGFONT)
	self.okbutton:SetColour(1,1,1,1)
	self.okbutton:SetOverColour(unpack(ST.A_AColours[3]))--(72/255,  252/255,  32/255, 1)
	self.okbutton:SetPosition(0,-35,0)
	self.okbutton:SetText('OK')
	self.okbutton:SetOnClick(function() self:OnTextEntered() end)
		
if inst.Label and inst.components.container then
	self.cpn_con = inst.components.container
	--show hide
	self.shbutton = self.root:AddChild(TextButton())
	self.shbutton:SetTextSize(20)
	self.shbutton:SetFont(DIALOGFONT)
	self.shbutton:SetColour(1,1,1,1)
	self.shbutton:SetOverColour(unpack(ST.A_AColours[3]))--(72/255,  252/255,  32/255, 1)
	self.shbutton:SetPosition(100,-35,0)
	self.shbutton:SetText(self.cpn_edt.LBEnable and 'Hide' or 'Show')
	self.shbutton:SetOnClick(function() self:ToggleLabel() end)
	--snow colour 
	self.scbutton = self.root:AddChild(TextButton())
	self.scbutton:SetTextSize(60)
	self.scbutton:SetFont(DIALOGFONT)
	self.scbutton:SetColour(unpack(ST.A_AColours[self.cpn_edt.SNOW_COLOUR]))
	self.scbutton:SetOverColour(unpack(ST.A_AColours[self.cpn_edt.SNOW_COLOUR]))
	self.scbutton:SetPosition(-120,30,0)
	self.scbutton:SetText('*')
	self.scbutton:SetOnClick(function() self:ChangeSC() end)	
	--colour 
	self.cbutton = self.root:AddChild(TextButton())
	self.cbutton:SetTextSize(60)
	self.cbutton:SetFont(DIALOGFONT)
	self.cbutton:SetColour(unpack(ST.A_AColours[self.cpn_edt.COLOUR]))
	self.cbutton:SetOverColour(unpack(ST.A_AColours[self.cpn_edt.COLOUR]))
	self.cbutton:SetPosition(120,30,0)
	self.cbutton:SetText('*')
	self.cbutton:SetOnClick(function() self:ChangeC() end)
	--font pos size
	self.grid = self.root:AddChild(Grid())
	self.grid:InitSize(5, 1, 175, -300)
	self.grid:SetPosition(-105, 100, 0)
	self.grid:SetScale(0.6, 0.5, 0.6)
	
	self.posSpinner = Spinner(self:GetPosList())
	self.posSpinner.OnChanged = function( _, data ) self:ChangePos(data) end

	self.fontsizeSpinner = Spinner(self:GetFSList())
	self.fontsizeSpinner.OnChanged = function( _, data ) self:ChangeFS(data) end

	self.fontSpinner = Spinner(self:GetFList())
	self.fontSpinner.OnChanged = function( _, data ) self:ChangeF(data) end

	local spinners = {}
	table.insert(spinners, self.posSpinner)
	table.insert(spinners, self.fontsizeSpinner)
	table.insert(spinners, self.fontSpinner)
	
	for k,v in ipairs(spinners) do self.grid:AddItem(self:CreateSpinnerGroup(v), k, 1) end
	
	self:InitializeSpinners()
end

	self.default_focus = self.console_edit

	self.console_edit.validrawkeys[KEY_UP] = true
	self.console_edit.validrawkeys[KEY_DOWN] = true
	--self.console_edit.validrawkeys[KEY_BACKSPACE] = true
	self.console_edit:SetAllowClipboardPaste(true)
end)

function A_AEdit_Screen:OnTextEntered()
	local str = self.console_edit:GetString()
	
	if self.cpn_con then
		if self.cpn_con.BAIBAO_CHEST or self.cpn_con.Chest_Method == 'ALL_SLOTS' then
			self.cpn_edt:SetString(str)
			self.cpn_edt:UpdataString()
		end
	else
		self.cpn_edt:SetString(str)
	end
	self.cpn_edt.edit_ = nil
	SetPause(false)
	TheFrontEnd:PopScreen()
end

function A_AEdit_Screen:GetPosList()
	if not self.poslist then self.poslist = {} else return self.poslist end
	for i = 1,15 do
		table.insert(self.poslist, {text = "Pos:"..tostring(i<6 and i/10 or i/5 -.5), data = i<6 and i/10 or i/5 -.5})
	end
	return self.poslist
end
function A_AEdit_Screen:GetFSList()
	if not self.fslist then self.fslist = {} else return self.fslist end
	for i = 1,16 do
		table.insert(self.fslist, {text = "Size:"..tostring(14+i), data = 14+i})
	end
	return self.fslist
end
function A_AEdit_Screen:GetFList()
	if not self.flist then self.flist = {} else return self.flist end
local TextFont = {BODYTEXTFONT,DIALOGFONT,UIFONT,BUTTONFONT,TALKINGFONT}
local Text = {'BodyText','Dialog','UI','Button','Talking'}
	for i = 1,#TextFont do
		table.insert(self.flist, {text = Text[i], data = TextFont[i]})
	end
	return self.flist
end

function A_AEdit_Screen:CreateSpinnerGroup(spinner)
	spinner:SetTextColour(0,0,0,1)
	spinner:SetTextSize(40)
	local group = Widget("SpinnerGroup")
	group:AddChild( spinner )
	spinner:SetPosition( 0, 0, 0 )
	group.focus_forward = spinner
	return group
end

function A_AEdit_Screen:ToggleLabel() --show hide
	self.cpn_edt.LBEnable = not self.cpn_edt.LBEnable
	self.shbutton:SetText(self.cpn_edt.LBEnable and 'Hide' or 'Show')
	self.cpn_edt:UpdataLabel()
end
function A_AEdit_Screen:ChangePos(data) -- pos
	self.cpn_edt.LABEL_POS = data
	self.cpn_edt:UpdataLabel()
end
function A_AEdit_Screen:ChangeFS(data) --size
	self.cpn_edt.LABEL_SIZE = data
	self.cpn_edt:UpdataLabel()
end
function A_AEdit_Screen:ChangeF(data) --font
	self.cpn_edt.LABEL_FONT = data
	self.cpn_edt:UpdataLabel()
end
function A_AEdit_Screen:ChangeSC() --snowcolour
	local cl = self.cpn_edt.SNOW_COLOUR
	cl = TheInput:IsKeyDown(KEY_CTRL) and cl-1 or cl+1
	cl = cl<1 and #ST.A_AColours or cl > #ST.A_AColours and 1 or cl
	self.cpn_edt.SNOW_COLOUR = cl
	self.cpn_edt:UpdataLabel()
	self.scbutton:SetColour(unpack(ST.A_AColours[cl]))
	self.scbutton:SetOverColour(unpack(ST.A_AColours[cl]))
end
function A_AEdit_Screen:ChangeC() --colour
	local cl = self.cpn_edt.COLOUR
	cl = TheInput:IsKeyDown(KEY_CTRL) and cl-1 or cl+1
	cl = cl<1 and #ST.A_AColours or cl > #ST.A_AColours and 1 or cl
	self.cpn_edt.COLOUR = cl
	self.cpn_edt:UpdataLabel()
	self.cbutton:SetColour(unpack(ST.A_AColours[cl]))
	self.cbutton:SetOverColour(unpack(ST.A_AColours[cl]))
end

function A_AEdit_Screen:InitializeSpinners()
	local pos = self:GetPosList()
	for i = 1,#pos do
		if math.abs(pos[i].data - self.cpn_edt.LABEL_POS)<.05 then 
			self.posSpinner:SetSelectedIndex(i)
			break
		end
	end
	local fs = self:GetFSList()
	for i = 1,#fs do
		if math.abs(fs[i].data - self.cpn_edt.LABEL_SIZE)<.05 then 
			self.fontsizeSpinner:SetSelectedIndex(i)
			break
		end
	end
	local font = self:GetFList()
	for i = 1,#font do
		if font[i].data == self.cpn_edt.LABEL_FONT then
			self.fontSpinner:SetSelectedIndex(i)
			break
		end
	end
end

return A_AEdit_Screen